// DemoDlgMsgPumpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoDlgMsgPump.h"
#include "DemoDlgMsgPumpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlgMsgPumpDlg dialog

CDemoDlgMsgPumpDlg::CDemoDlgMsgPumpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlgMsgPumpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlgMsgPumpDlg)
	m_sMessage = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlgMsgPumpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlgMsgPumpDlg)
	DDX_Text(pDX, IDC_myMessage, m_sMessage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlgMsgPumpDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlgMsgPumpDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_StartCount, OnStartCount)
	ON_BN_CLICKED(IDC_StopCount, OnStopCount)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlgMsgPumpDlg message handlers

BOOL CDemoDlgMsgPumpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlgMsgPumpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CDemoDlgMsgPumpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlgMsgPumpDlg::OnStartCount() 
{
	// Initialize our demo varfiables
	int m_dCount=0;								// our counter variable
	m_bAborted=FALSE;							// Our boolean flag
	m_sMessage="";								// Our Display String
	
	// Our loop
	while (!m_bAborted)	{	                                //Run until Told to Abort
		m_dCount++;                                         //Increment Counter 
		m_sMessage.Format("Message Number : %d",m_dCount);  //Format our Message
		UpdateData(FALSE);                                  //Update the dialog with its variables

		// Process all Pending Messages
		// to process only one per cycle
		// Use :  
		//       ProcessDialogMessages();
		//
        // The line above works just as well 
		// and allows our loop to run faster than
		// teh line below.

		while (ProcessDialogMessages());					//Process All pending messages
		        
	}
}

void CDemoDlgMsgPumpDlg::OnStopCount() 
{
	m_bAborted=TRUE;		// set our Flag to Abort the loop defined in OnStartCount
}

BOOL CDemoDlgMsgPumpDlg::ProcessDialogMessages()
{
	Sleep(0);	//Yield to other system processes

	// Process the message queue 
	MSG	dlgMsg;
	if (::PeekMessage (&dlgMsg, NULL, 0, 0, PM_NOREMOVE))	// If there are pending messages
	{
        if (!AfxGetApp ()->PumpMessage ()) {					// Allow them to be processed
            ::PostQuitMessage (0);								// When no more messages exist 
			                                                    // return WM_QUIT should return 0
			return TRUE;										// Return the caller indicating that 
			                                                    // we just processed a Message 
			                                                    // and that there may be more
        }
    }

    // Simulate idle processing .
    LONG lIdle = 0;
    while (AfxGetApp ()->OnIdle (lIdle++));
	return FALSE;												// Return to Caller saying
	                                                            // that we did not process
	                                                            // any messages 
}



void CDemoDlgMsgPumpDlg::OnOK() 
{
	m_bAborted=TRUE;	// If we are in a loop, ensure that our loop aborts
	CDialog::OnOK();
}
